//find roots of polynomials
use arrayvec::ArrayVec;
use crate::integer::Planar64;

fn one(z0:Planar64)->ArrayVec<Planar64,2>{
	let mut zeroes=ArrayVec::new();
	unsafe{zeroes.push_unchecked(z0)}
	zeroes
}

#[inline]
pub fn zeroes2(a0:Planar64,a1:Planar64,a2:Planar64)->ArrayVec<Planar64,2>{
	if a2==Planar64::ZERO{
		return zeroes1(a0,a1);
	}
	let radicand=a1.get() as i128*a1.get() as i128-a2.get() as i128*a0.get() as i128*4;
	if 0<radicand{
		//start with f64 sqrt
		//failure case: 2^63 < sqrt(2^127)
		let planar_radicand=Planar64::raw(unsafe{(radicand as f64).sqrt().to_int_unchecked()});
		//TODO: one or two newtons
		//sort roots ascending and avoid taking the difference of large numbers
		match (Planar64::ZERO<a2,Planar64::ZERO<a1){
			(true, true )=>[(-a1-planar_radicand)/(a2*2),(a0*2)/(-a1-planar_radicand)].into(),
			(true, false)=>[(a0*2)/(-a1+planar_radicand),(-a1+planar_radicand)/(a2*2)].into(),
			(false,true )=>[(a0*2)/(-a1-planar_radicand),(-a1-planar_radicand)/(a2*2)].into(),
			(false,false)=>[(-a1+planar_radicand)/(a2*2),(a0*2)/(-a1+planar_radicand)].into(),
		}
	}else if radicand==0{
		return one(a1/(a2*-2));
	}else{
		return ArrayVec::new_const();
	}
}
#[inline]
pub fn zeroes1(a0:Planar64,a1:Planar64)->ArrayVec<Planar64,2>{
	if a1==Planar64::ZERO{
		return ArrayVec::new_const();
	}else{
		let q=((-a0.get() as i128)<<32)/(a1.get() as i128);
		if i64::MIN as i128<=q&&q<=i64::MAX as i128{
			return one(Planar64::raw(q as i64));
		}else{
			return ArrayVec::new_const();
		}
	}
}
